﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Timers;

namespace wpfClock
{
    public sealed class DateTime2AngleService : INotifyPropertyChanged
    {
        
        public double Hour 
        {
            get { return _hour; }
            set
            {
                _hour = value;
                OnPropertyChanged("Hour");
            }
        }
        public double Minute
        {
            get { return _minute; }
            set
            {
                _minute = value;
                OnPropertyChanged("Minute");
            }
        }
        public double Second
        {
            get { return _second; }
            set
            {
                _second = value;
                OnPropertyChanged("Second");
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;

        public DateTime2AngleService()
        {
            initialDateTime();
            _tiemr = new Timer(1000);
            _tiemr.Elapsed += _tiemr_Elapsed;
            _tiemr.Start();
        }
        ~DateTime2AngleService()
        {
            _tiemr.Stop();
            _tiemr.Dispose();
        }
        void _tiemr_Elapsed(object sender, ElapsedEventArgs e)
        {
            initialDateTime();
        }
        void initialDateTime()
        {
            double angle = 0d;
            var vhour = DateTime.Now.Hour;

            var vsecond = DateTime.Now.Second;

            angle = 270 + vsecond * 6;// 秒针 一秒钟转6度 
            angle = angle > 360 ? angle - 360 : angle;
            Second = angle;

            var vminute = DateTime.Now.Minute;

            angle = 270 + vminute * 6;// 分针 一分钟转6度 
            angle = angle > 360 ? angle - 360 : angle;
            Minute = angle;

            vhour = vhour > 12 ? vhour - 12 : vhour; //12小时制
            angle = 270 + vhour * 30;// 时针 1小时转30度 
            angle = angle > 360 ? angle - 360 : angle;
            //时针角度与分针也有关系，整点角度+分针偏移
            Hour = angle + vminute / 10 * 5;

           

           
           
        }


        private void OnPropertyChanged(string info)
        {
           
            if (this.PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(info));
        }

        private double _hour, _minute, _second;

        private Timer _tiemr;

        
    }
}
